/*
 Copyright 2006 Opera Software ASA. All rights reserved.
 
This file contains Original Code and/or Contributions to the Original 
Code as defined in the Opera Web Applications License (the License). 
You may not use this file except in compliance with the License. Please 
obtain a copy of the License at http://www.opera.com/license/owal/
and read it before using this file. 

The Original Code and all Contributions to the Original Code distributed 
under the License are distributed on an AS IS basis, WITHOUT WARRANTY 
OF ANY KIND, EITHER EXPRESS OR IMPLIED, AND OPERA HEREBY DISCLAIMS ALL 
SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF 
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. 

Please see the License for the specific language governing rights and 
limitations under the License.  
*/
var currentStatus = 0;
var activated = 1;
var animating = 0;
visibleSide="Front";
function toggleSide(){
if(visibleSide=="Back") {
		document.getElementById("front").style.display="block";
		document.getElementById("back").style.display="none";
		visibleSide="Front"
	}	else {
		document.getElementById("front").style.display="none";
		document.getElementById("back").style.display="block";
		visibleSide="Back"
	}
}

function init(){
	activated=1;
  createFlipButton("front","backButton");
  createFlipButton("back","frontButton");
}
function toggleButtons(){
	
	if(animating == 0) {
		selectedItem = document.getElementById("buttonsHolder");
		var trans = selectedItem.createTransition();
		trans.transform=function(x) {
			var sin=Math.sin;
			var pi=Math.PI
			var start=0.1;
			return (sin((x)/100*pi))+start;
		};
		trans.callback = function(){
			animating = 0;
		};
		if(!selectedItem.style.top)
			selectedItem.style.top=15;
		animating = 1;
		if(currentStatus==0) {
			currentStatus = 1;	
			trans.add('top',selectedItem.style.top,'110px').execute();
		} else {
			currentStatus = 0;	
			trans.add('top',selectedItem.style.top,'15px').execute();
		}
	}
}


//ButtonHIT function, calls drawing function
function buttonHit(buttonTitle){
	clearPlayArea();
	buttonLabel = "button" + activated;		
	switch(buttonTitle) {
		case "temp":
			activated = 1;
			shiftValue = 80;
			temperatureLayout();
			break;
		case "distance":
			activated = 2;
			shiftValue = 140;
			distanceLayout();
			break;
		case "weight":
			activated = 3;
			shiftValue = 20;
			weightLayout();
			break;
		case "area":
			activated = 4;
			shiftValue = 160;
			areaLayout();
			break;
		case "numbers":
			activated = 5;
			shiftValue = 120;
			numbersLayout();
			break;
		case "velocity":
			activated = 6;
			shiftValue = 60;
			velocityLayout();
			break;
		case "volume":
			activated = 7;
			shiftValue = 40;
			volumeLayout();
			break;
		case "pressure":
			activated = 8;
			shiftValue = 100;
			pressureLayout();			
			break;
	}
	buttonLabel = "button" + activated;
	document.getElementById("titleImage").style.backgroundPosition = "0px " + shiftValue + "px";
	toggleButtons();
}

//DRAWING functions for each type
function clearPlayArea(){
	document.getElementById("playArea").innerHTML = "";
}
function parseComma(value){
	value = value.replace(",", ".");
	return value;
}
function setDecimalSpaces(value){
	if(!value) {
		value = "Incorrect input";
	} else {
		var eValue = 0;
		while(value > 1000000000) {
			value /= 10;
			eValue++;
		}
		value *= 100;
		value = Math.floor(value);
		value /= 100;
		if(eValue>0)
			value = value + ' E' + eValue;
	}
	return value;
}
function valueToValueLayout(){
	document.getElementById("playArea").innerHTML = '<form id="vToVForm"><select id="from"></select><select id="to"></select><br/><input type="text" id="how_much" maxlength="14" /><input type="text" id="output" /></form>';
	fromHandle = document.getElementById('from');
	toHandle = document.getElementById('to');
	inputValue = document.getElementById('how_much');
	outputHandle = document.getElementById('output');
	vToVFormHandle	= document.getElementById('vToVForm');
}
function temperatureLayout(){
	valueToValueLayout();
	
	fromHandle.options[fromHandle.options.length] = new Option( "Celcius", "0" );
	fromHandle.options[fromHandle.options.length] = new Option( "Fahrenhiet", "1" );
	fromHandle.options[fromHandle.options.length] = new Option( "Kelvin", "2" );
	
	toHandle.options[toHandle.options.length] = new Option( "Celcius", "0" );
	toHandle.options[toHandle.options.length] = new Option( "Fahrenhiet",  "1" );
	toHandle.options[toHandle.options.length] = new Option( "Kelvin",  "2" );
		
	inputValue.onkeyup= function( )
	{
		if(inputValue.value == "") {
			inputValue.value = "1";
		}
		var output = 0;
		
		VAL = parseComma(inputValue.value);
		switch(fromHandle.value){
			case "0":
				switch(toHandle.value){
					case "0":
						output = VAL;
					break;
					case "1":
						output = (Math.round(((212-32)/100 * parseFloat(VAL) + 32)*100))/100;
					break;
					case "2":
						output = parseFloat(VAL) + 273;
					break;
				}
			break;
			case "1":
				switch(toHandle.value){
					case "0":
						output = (Math.round((100/(212-32) * (parseFloat(VAL) - 32))*100))/100;
					break;
					case "1":
						output = VAL;
					break;
					case "2":
						output = (Math.round((100/(212-32) * (parseFloat(VAL) - 32))*100))/100 + 273;
					break;
				}
			break;
			case "2":
				switch(toHandle.value){
					case "0":
						output = (Math.round(parseFloat(VAL) - 273));
					break;
					case "1":
						output = (Math.round(((212-32)/100 *(parseFloat(VAL) - 273) + 32)*100))/100;
					break;
					case "2":
						output = VAL;
					break;
				}
			break;
		}
		outputHandle.value = setDecimalSpaces(output);
		return false;
	}
	fromHandle.onchange = inputValue.onkeyup;
	toHandle.onchange = inputValue.onkeyup;
}
function distanceLayout(){
	valueToValueLayout();
	
	fromHandle.options[fromHandle.options.length] = new Option( "Centimetres", "0" );
	fromHandle.options[fromHandle.options.length] = new Option( "Metres", "1" );
	fromHandle.options[fromHandle.options.length] = new Option( "Kilometres", "2" );
	fromHandle.options[fromHandle.options.length] = new Option( "Miles", "3" );
	fromHandle.options[fromHandle.options.length] = new Option( "Inches", "4" );
	fromHandle.options[fromHandle.options.length] = new Option( "Feet", "5" );
	fromHandle.options[fromHandle.options.length] = new Option( "Yards", "6" );
	
	toHandle.options[toHandle.options.length] = new Option( "Centimetres", "0" );
	toHandle.options[toHandle.options.length] = new Option( "Metres", "1" );
	toHandle.options[toHandle.options.length] = new Option( "Kilometres", "2" );
	toHandle.options[toHandle.options.length] = new Option( "Miles", "3" );
	toHandle.options[toHandle.options.length] = new Option( "Inches", "4" );
	toHandle.options[toHandle.options.length] = new Option( "Feet", "5" );
	toHandle.options[toHandle.options.length] = new Option( "Yards", "6" );
	
	inputValue.onkeyup= function( )
	{
		if(inputValue.value == "") {
			inputValue.value = "1";
		}
		VAL = parseComma(inputValue.value);
		
		var ratio0 = new Array(1, 0.01, 0.00001, 0.00000621, 0.3937, 0.0328, 0.01094);
		var ratio1 = new Array(100, 1, 0.001, 0.000621, 39.37, 3.28,  1.094);
		var ratio2 = new Array(100000, 1000, 1, 0.621, 39370, 3280, 1094);
		var ratio3 = new Array(160934, 1609.34, 1.60934, 1, 63360, 5280,1760);
		var ratio4 = new Array(2.54, 0.0254, 0.0000254, 0.0000158, 1, 0.08333, 0.02778);
		var ratio5 = new Array(30.48, 0.3048, 0.0003048, 0.0001896, 12, 1, 0.3333);
		var ratio6 = new Array(91.44, 0.9144, 0.0009144, 0.0005688, 36, 3, 1);
		var matrix = new Array(ratio0,ratio1,ratio2,ratio3,ratio4,ratio5,ratio6);
		var factor = matrix[parseInt(fromHandle.value)][parseInt(toHandle.value)];
		
		var output = factor * VAL;
		
		outputHandle.value = setDecimalSpaces(output);
		return false;
	}
	fromHandle.onchange = inputValue.onkeyup;
	toHandle.onchange = inputValue.onkeyup;
}
function weightLayout(){
	valueToValueLayout();
	
	fromHandle.options[fromHandle.options.length] = new Option( "Grams", "0" );
	fromHandle.options[fromHandle.options.length] = new Option( "Kilograms", "1" );
	fromHandle.options[fromHandle.options.length] = new Option( "Ounces", "2" );
	fromHandle.options[fromHandle.options.length] = new Option( "Pounds", "3" );
	fromHandle.options[fromHandle.options.length] = new Option( "Troy Pounds", "4" );
	fromHandle.options[fromHandle.options.length] = new Option( "Stones", "5" );
	fromHandle.options[fromHandle.options.length] = new Option( "Short Tons", "6" );
	fromHandle.options[fromHandle.options.length] = new Option( "Long Tons", "7" );

	toHandle.options[toHandle.options.length] = new Option( "Grams", "0" );
	toHandle.options[toHandle.options.length] = new Option( "Kilograms", "1" );
	toHandle.options[toHandle.options.length] = new Option( "Ounces", "2" );
	toHandle.options[toHandle.options.length] = new Option( "Pounds", "3" );
	toHandle.options[toHandle.options.length] = new Option( "Troy Pounds", "4" );
	toHandle.options[toHandle.options.length] = new Option( "Stones", "5" );
	toHandle.options[toHandle.options.length] = new Option( "Short Tons", "6" );
	toHandle.options[toHandle.options.length] = new Option( "Long Tons", "7" );

	inputValue.onkeyup= function( )
	{
		if(inputValue.value == "") {
			inputValue.value = "1";
		}
		VAL = parseComma(inputValue.value);
			
		var ratio0 = new Array(1.0000000000, 0.0010000000, 0.0352739440, 0.0022046215, 0.0026792765, 0.0001574731, 0.0000011023, 0.0000010000);
		var ratio1 = new Array(1000.0000000000, 1.0000000000, 35.2739440000, 2.2046215000, 2.6792765000, 0.1574731233, 0.0011023108, 0.0010000000);
		var ratio2 = new Array(28.3495375510, 0.0283495376, 1.0000000000, 16.0000000000, 13.1654735896, 223.9997738437, 32000.0000000000, 35273.9440000000);
		var ratio3 = new Array(453.5926008161, 0.4535926008, 0.0625000000, 1.0000000000, 1.2152999959, 0.0714286435, 0.0005000000, 0.0004535926);
		var ratio4 = new Array(373.2350879053, 0.3732350879, 0.0759562497, 0.8228420994, 1.0000000000, 17.0141827652, 2430.5999918807, 2679.2765000000);
		var ratio5 = new Array(6350.2899999994, 6.3502900000, 0.0044642902, 13.9999858652, 0.0587744950, 1.0000000000, 0.0069999929, 0.0063502900);
		var ratio6 = new Array(907185.2016321170, 907.1852016321, 0.0000312500, 2000.0000000000, 0.0004114210, 142.8572870896, 1.0000000000, 1.1023107500);
		var ratio7 = new Array(1000000.0000000000, 1000.0000000000, 0.0000283495, 2204.6215000000, 0.0003732351, 157.4731232747, 0.9071852016, 1.0000000000);
				
		var matrix = new Array(ratio0,ratio1,ratio2,ratio3,ratio4,ratio5,ratio6,ratio7);
		var factor = matrix[parseInt(fromHandle.value)][parseInt(toHandle.value)];
		
		var output = factor * VAL;
		
		outputHandle.value = setDecimalSpaces(output);
		return false;
	}
	fromHandle.onchange = inputValue.onkeyup;
	toHandle.onchange = inputValue.onkeyup;
}
function numbersLayout(){
	valueToValueLayout();
	
	fromHandle.options[fromHandle.options.length] = new Option( "Binary", "2" );
	fromHandle.options[fromHandle.options.length] = new Option( "Ternary", "3" );
	fromHandle.options[fromHandle.options.length] = new Option( "Quaternary", "4" );
	fromHandle.options[fromHandle.options.length] = new Option( "Quinary", "5" );
	fromHandle.options[fromHandle.options.length] = new Option( "Senary", "6" );
	fromHandle.options[fromHandle.options.length] = new Option( "Septenary", "7" );
	fromHandle.options[fromHandle.options.length] = new Option( "Octal", "8" );
	fromHandle.options[fromHandle.options.length] = new Option( "Nonary", "9" );
	fromHandle.options[fromHandle.options.length] = new Option( "Decimal", "10" );
	fromHandle.options[fromHandle.options.length] = new Option( "Undecimal", "11" );
	fromHandle.options[fromHandle.options.length] = new Option( "Duodecimal", "12" );
	fromHandle.options[fromHandle.options.length] = new Option( "Tridecimal", "13" );
	fromHandle.options[fromHandle.options.length] = new Option( "Hexadecimal", "16" );
	fromHandle.options[fromHandle.options.length] = new Option( "Vigesimal", "20" );
	fromHandle.options[fromHandle.options.length] = new Option( "Quadrovigesimal", "24" );
	fromHandle.options[fromHandle.options.length] = new Option( "Hexavigesimal", "26" );
	fromHandle.options[fromHandle.options.length] = new Option( "Septemvigesimal", "27" );
	fromHandle.options[fromHandle.options.length] = new Option( "Trigesimal", "30" );
	fromHandle.options[fromHandle.options.length] = new Option( "Duotrigesimal", "32" );
	fromHandle.options[fromHandle.options.length] = new Option( "Sexatrigesimal", "36" );

	
	toHandle.options[toHandle.options.length] = new Option( "Binary", "2" );
	toHandle.options[toHandle.options.length] = new Option( "Ternary", "3" );
	toHandle.options[toHandle.options.length] = new Option( "Quaternary", "4" );
	toHandle.options[toHandle.options.length] = new Option( "Quinary", "5" );
	toHandle.options[toHandle.options.length] = new Option( "Senary", "6" );
	toHandle.options[toHandle.options.length] = new Option( "Septenary", "7" );
	toHandle.options[toHandle.options.length] = new Option( "Octal", "8" );
	toHandle.options[toHandle.options.length] = new Option( "Nonary", "9" );
	toHandle.options[toHandle.options.length] = new Option( "Decimal", "10" );
	toHandle.options[toHandle.options.length] = new Option( "Undecimal", "11" );
	toHandle.options[toHandle.options.length] = new Option( "Duodecimal", "12" );
	toHandle.options[toHandle.options.length] = new Option( "Tridecimal", "13" );
	toHandle.options[toHandle.options.length] = new Option( "Hexadecimal", "16" );
	toHandle.options[toHandle.options.length] = new Option( "Vigesimal", "20" );
	toHandle.options[toHandle.options.length] = new Option( "Quadrovigesimal", "24" );
	toHandle.options[toHandle.options.length] = new Option( "Hexavigesimal", "26" );
	toHandle.options[toHandle.options.length] = new Option( "Septemvigesimal", "27" );
	toHandle.options[toHandle.options.length] = new Option( "Trigesimal", "30" );
	toHandle.options[toHandle.options.length] = new Option( "Duotrigesimal", "32" );
	toHandle.options[toHandle.options.length] = new Option( "Sexatrigesimal", "36" );
	
	inputValue.onkeyup= function( )
	{
		if(inputValue.value == "") {
			inputValue.value = "1";
		}
		var origin = fromHandle.value.toString(); 
		var dest = toHandle.value.toString();
		outputHandle.value = convert(inputValue.value,origin,dest);
		return false;
	}
	fromHandle.onchange = inputValue.onkeyup;
	toHandle.onchange = inputValue.onkeyup;
}
function convert(input,origin,dest) {
	var convertBase="0123456789ABCDSEFGHIJKLMNOPQRSTUVWXYZ";	
	var input=input.toString().toLowerCase(); 
	var origin=origin.toString(); 
	var dest=dest.toString();
	var b=0; 
	var result="";
	if (Number(origin)>convertBase.length || Number(dest)>convertBase.length || Number(origin)<2 || Number(dest)<2) 
		return "Invalid numbering system";
	for (var c = 1; c <= input.length; c++) 
	{ 
		b += convertBase.indexOf(input.substring(c-1,c))*(Math.pow(origin,input.length-c)); 
		if (convertBase.indexOf(input.substring(c-1,c)) > Number(origin)) 
			return 'Character "'+input.substring(c-1,c)+'" not present in origin system'; 
	}
	var a = Math.floor(Math.log(b)/Math.log(dest))
	while (a>-1) {
		var e = Math.pow(dest,a)
		a--;
		var d = (b-b%e)/e+1;
		b %= e;
		carrier = convertBase.substring(d-1,d);
		result += carrier;
	}
	return result
}
function areaLayout(){
	valueToValueLayout();
	
	fromHandle.options[fromHandle.options.length] = new Option( "Square Meters", "0" );
	fromHandle.options[fromHandle.options.length] = new Option( "Square Inches", "1" );
	fromHandle.options[fromHandle.options.length] = new Option( "Square Feet", "2" );
	fromHandle.options[fromHandle.options.length] = new Option( "Square Yards", "3" );
	fromHandle.options[fromHandle.options.length] = new Option( "Square Rods", "4" );
	fromHandle.options[fromHandle.options.length] = new Option( "Square Chains", "5" );
	fromHandle.options[fromHandle.options.length] = new Option( "Roods", "6" );
	fromHandle.options[fromHandle.options.length] = new Option( "Acres", "7" );
	fromHandle.options[fromHandle.options.length] = new Option( "Square Miles", "8" );
	
	toHandle.options[toHandle.options.length] = new Option( "Square Meters", "0" );
	toHandle.options[toHandle.options.length] = new Option( "Square Inches", "1" );
	toHandle.options[toHandle.options.length] = new Option( "Square Feet", "2" );
	toHandle.options[toHandle.options.length] = new Option( "Square Yards", "3" );
	toHandle.options[toHandle.options.length] = new Option( "Square Rods", "4" );
	toHandle.options[toHandle.options.length] = new Option( "Square Chains", "5" );
	toHandle.options[toHandle.options.length] = new Option( "Roods", "6" );
	toHandle.options[toHandle.options.length] = new Option( "Acres", "7" );
	toHandle.options[toHandle.options.length] = new Option( "Square Miles", "8" );
	
	inputValue.onkeyup= function( )
	{
		if(inputValue.value == "") {
			inputValue.value = "1";
		}
		VAL = parseComma(inputValue.value);
		
		var ratio0 = new Array(1, 1550, 10.76, 1.196, 0.0395, 0.002471, 0.0009884, 0.0002471, 0.0000003861);
		var ratio1 = new Array(0.0006452, 1, 0.006944, 0.0007716, 0.00002551, 0.000001594, 0.0000006377, 0.0000001594, 2.291e-10);
		var ratio2 = new Array(0.09290, 144, 1, 0.1111, 0.003673, 0.0002296, 0.00009183, 0.00002296, 3.587e-8);
		var ratio3 = new Array(0.8361, 1296, 9, 1, 0.03306, 0.002066, 0.0008264, 0.0002066, 3.228e-7);
		var ratio4 = new Array(25.29, 39204, 272.25, 30.25, 1, 0.0625, 0.025, 0.00625, 9.766e-6);
		var ratio5 = new Array(404.7, 627264, 4356, 484, 16, 1, 0.4, 0.1, 0.00015625);
		var ratio6 = new Array(1012, 1568160, 10890, 1210, 40, 2.5, 1, 0.25, 0.000390625);
		var ratio7 = new Array(4047, 6272640, 43560, 4840, 160, 10, 4, 1, 0.0015625);
		var ratio8 = new Array(2589988, 4013355318, 27878400, 3097600, 102400, 6400, 2560, 640, 1);
		
		var matrix = new Array(ratio0,ratio1,ratio2,ratio3,ratio4,ratio5,ratio6,ratio7,ratio8);
		var factor = matrix[parseInt(fromHandle.value)][parseInt(toHandle.value)];
		
		var output = factor * VAL;
		
		outputHandle.value = setDecimalSpaces(output);
		return false;
	}
	fromHandle.onchange = inputValue.onkeyup;
	toHandle.onchange = inputValue.onkeyup;
}
function velocityLayout(){
	valueToValueLayout();
	
	fromHandle.options[fromHandle.options.length] = new Option( "cm/sec", "0" );
	fromHandle.options[fromHandle.options.length] = new Option( "m/sec", "1" );
	fromHandle.options[fromHandle.options.length] = new Option( "m/min", "2" );
	fromHandle.options[fromHandle.options.length] = new Option( "km/hr", "3" );
	fromHandle.options[fromHandle.options.length] = new Option( "ft/sec", "4" );
	fromHandle.options[fromHandle.options.length] = new Option( "ft/min", "5" );
	fromHandle.options[fromHandle.options.length] = new Option( "mi/hr", "6" );
	fromHandle.options[fromHandle.options.length] = new Option( "knots", "7" );
	
	toHandle.options[toHandle.options.length] = new Option( "cm/sec", "0" );
	toHandle.options[toHandle.options.length] = new Option( "m/sec", "1" );
	toHandle.options[toHandle.options.length] = new Option( "m/min", "2" );
	toHandle.options[toHandle.options.length] = new Option( "km/hr", "3" );
	toHandle.options[toHandle.options.length] = new Option( "ft/sec", "4" );
	toHandle.options[toHandle.options.length] = new Option( "ft/min", "5" );
	toHandle.options[toHandle.options.length] = new Option( "mi/hr", "6" );
	toHandle.options[toHandle.options.length] = new Option( "knots", "7" );
		
	inputValue.onkeyup= function( )
	{
		if(inputValue.value == "") {
			inputValue.value = "1";
		}
		VAL = parseComma(inputValue.value);
		
		var ratio0 = new Array(1, 0.01, 0.6, 0.036, 0.03281, 1.9685, 0.02237, 0.01944);
		var ratio1 = new Array(100, 1, 60, 3.6, 3.281, 196.85, 2.237, 1.944);
		var ratio2 = new Array(1.66667, 0.016667, 1, 0.06, 0.05468, 3.281, 0.03728, 0.03240);
		var ratio3 = new Array(27.78, 0.2778, 16.6667, 1, 0.9113, 54.68, 0.6214, 0.53996);
		var ratio4 = new Array(0.48, 0.3048, 18.29, 1.097, 1, 60, 0.68181818, 0.59248);
		var ratio5 = new Array(0.5080, 0.00508, 0.3048, 0.01829, 0.016667, 1, 0.01136, 0.00987);
		var ratio6 = new Array(44.7, 0.447, 26.82, 1.609, 1.467, 88, 1, 0.86898);
		var ratio7 = new Array(51.44, 0.5144, 30.87, 1.852, 1.688, 101.3, 1.151, 1);		
		
		var matrix = new Array(ratio0,ratio1,ratio2,ratio3,ratio4,ratio5,ratio6,ratio7);
		var factor = matrix[parseInt(fromHandle.value)][parseInt(toHandle.value)];
		
		var output = factor * VAL;
		
		outputHandle.value = setDecimalSpaces(output);
		return false;
	}
	fromHandle.onchange = inputValue.onkeyup;
	toHandle.onchange = inputValue.onkeyup;
}
function volumeLayout(){
	valueToValueLayout();
	
	fromHandle.options[fromHandle.options.length] = new Option( "cm Cube", "0" );
	fromHandle.options[fromHandle.options.length] = new Option( "meter cube", "1" );
	fromHandle.options[fromHandle.options.length] = new Option( "cubic inches", "2" );
	fromHandle.options[fromHandle.options.length] = new Option( "cubic feet", "3" );
	fromHandle.options[fromHandle.options.length] = new Option( "cubic yards", "4" );	
	
	toHandle.options[toHandle.options.length] = new Option( "cm Cube", "0" );
	toHandle.options[toHandle.options.length] = new Option( "meter cube", "1" );
	toHandle.options[toHandle.options.length] = new Option( "cubic inches", "2" );
	toHandle.options[toHandle.options.length] = new Option( "cubic feet", "3" );
	toHandle.options[toHandle.options.length] = new Option( "cubic yards", "4" );	
	
	inputValue.onkeyup= function( )
	{
		if(inputValue.value == "") {
			inputValue.value = "1";
		}
		VAL = parseComma(inputValue.value);
		
		var ratio0 = new Array(1.0000000000, 0.0000010000, 0.0610240000, 0.0000352876, 0.0000013093);
		var ratio1 = new Array(1000000.0000000000, 1.0000000000, 61023.3779530000, 35.3146670000, 1.3079510000);
		var ratio2 = new Array(16.3869952805, 0.0000163872, 1.0000000000, 1728.0000000000, 1.3093385840);
		var ratio3 = new Array(28338.6050695724, 0.0283168464, 0.0005787037, 1.0000000000, 0.0370259270);
		var ratio4 = new Array(763744.3914201490, 0.7645546355, 0.7637443914, 27.0081016203, 1.0000000000);
				
		var matrix = new Array(ratio0,ratio1,ratio2,ratio3,ratio4);
		var factor = matrix[parseInt(fromHandle.value)][parseInt(toHandle.value)];
		
		var output = factor * VAL;
		
		outputHandle.value = setDecimalSpaces(output);
		return false;
	}
	fromHandle.onchange = inputValue.onkeyup;
	toHandle.onchange = inputValue.onkeyup;
}
function pressureLayout(){
	valueToValueLayout();
	
	fromHandle.options[fromHandle.options.length] = new Option( "megadynes/sq cm", "0" );
	fromHandle.options[fromHandle.options.length] = new Option( "kg/sq cm", "1" );
	fromHandle.options[fromHandle.options.length] = new Option( "lb/sq in", "2" );
	fromHandle.options[fromHandle.options.length] = new Option( "atmospheres", "3" );
	fromHandle.options[fromHandle.options.length] = new Option( "Hg*meters", "4" );
	fromHandle.options[fromHandle.options.length] = new Option( "Hg*inches", "5" );
	fromHandle.options[fromHandle.options.length] = new Option( "H2O*meters", "6" );
	fromHandle.options[fromHandle.options.length] = new Option( "H2O*inches", "7" );
	fromHandle.options[fromHandle.options.length] = new Option( "H2O*feet", "8" );
	
	toHandle.options[toHandle.options.length] = new Option( "megadynes/sq cm", "0" );
	toHandle.options[toHandle.options.length] = new Option( "kg/sq cm", "1" );
	toHandle.options[toHandle.options.length] = new Option( "lb/sq in", "2" );
	toHandle.options[toHandle.options.length] = new Option( "atmospheres", "3" );
	toHandle.options[toHandle.options.length] = new Option( "Hg*meters", "4" );
	toHandle.options[toHandle.options.length] = new Option( "Hg*inches", "5" );
	toHandle.options[toHandle.options.length] = new Option( "H2O*meters", "6" );
	toHandle.options[toHandle.options.length] = new Option( "H2O*inches", "7" );
	toHandle.options[toHandle.options.length] = new Option( "H2O*feet", "8" );
	
	inputValue.onkeyup= function( )
	{
		if(inputValue.value == "") {
			inputValue.value = "1";
		}
		VAL = parseComma(inputValue.value);

		var ratio0 = new Array(1, 1.0197, 14.5, 0.9869, 0.7501, 29.53, 10.21, 401.8, 33.49);
		var ratio1 = new Array(0.9807, 1, 14.22, 0.9678, 0.7356, 28.96, 10.01, 394.1, 32.84);
		var ratio2 = new Array(0.06895, 0.07031, 1, 0.06805, 0.05171, 2.036, 0.7037, 27.7, 2.309);
		var ratio3 = new Array(1.0133, 1.0332, 14.7, 1, 0.76, 29.92, 10.34, 407.1, 33.93);
		var ratio4 = new Array(1.3332, 1.3595, 19.34, 1.316, 1, 39.37, 13.61, 535.7, 44.64);
		var ratio5 = new Array(0.03386, 0.03453, 0.4912, 0.03342, 0.0254, 1, 0.3456, 13.61, 1.134);
		var ratio6 = new Array(0.09798, 0.09991, 1.421, 0.0967, 0.07349, 2.893, 1, 39.37, 3.281);
		var ratio7 = new Array(0.002489, 0.002538, 0.03609, 0.002456, 0.001867, 0.07349, 0.02540, 1, 0.083333);
		var ratio8 = new Array(0.02986, 0.03045, 0.4331, 0.02947, 0.0224, 0.8819, 0.3048, 12, 1);		
		
		var matrix = new Array(ratio0,ratio1,ratio2,ratio3,ratio4,ratio5,ratio6,ratio7,ratio8);
		var factor = matrix[parseInt(fromHandle.value)][parseInt(toHandle.value)];
		
		var output = factor * VAL;
		
		outputHandle.value = setDecimalSpaces(output);
		return false;
	}
	fromHandle.onchange = inputValue.onkeyup;
	toHandle.onchange = inputValue.onkeyup;
}

var currentElement = null;

var addFocus = function() {

  if(currentElement != null) {
    currentElement.className = currentElement.oldClassName;
  }
  
  this.oldClassName = this.className;
  this.className += " focus";
  currentElement = this;
}

var addSpatialNavigation = function() {
  
  document.getElementById("area").onfocus = addFocus;
  document.getElementById("distance").onfocus = addFocus;
  document.getElementById("numbers").onfocus = addFocus;
  document.getElementById("pressure").onfocus = addFocus;
  document.getElementById("temp").onfocus = addFocus;
  document.getElementById("velocity").onfocus = addFocus;
  document.getElementById("volume").onfocus = addFocus;
  document.getElementById("weight").onfocus = addFocus;

  return;
  
}

onload = function() {
  addSpatialNavigation();
}
